/*****************************************************************************

        GRAOUMF TRACKER 2
        Author: Laurent de Soras, 1996-2016

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*****************************************************************************/



#if defined (SDRVDX_CURRENT_HEADER)
	#error Inclusion recursive du header SDRVDX.
#endif
#define	SDRVDX_CURRENT_HEADER

#if ! defined (SDRVDX_HEADER_INCLUDED)
#define	SDRVDX_HEADER_INCLUDED



/*\\\ INCLUDES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	"archi.h"
#include	"SoundDriver.h"



/*\\\ CONSTANTES PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ TYPES & STRUCTURES PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ PROTOTYPES DES FONCTIONS PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

signed int cdecl	SDRVDX_init (void *param_ptr);
signed int cdecl	SDRVDX_restore (void);
signed int cdecl	SDRVDX_set_config (SoundDriver_CONFIG *config_ptr);
signed int cdecl	SDRVDX_get_config (SoundDriver_CONFIG *config_ptr);
signed int cdecl	SDRVDX_start_replay (void);
signed int cdecl	SDRVDX_stop_replay (void);
signed int cdecl	SDRVDX_set_new_frame (long frame_length);
signed int cdecl	SDRVDX_set_data (float *out_buffer_ptr [], float *out_clip_ptr);
signed int cdecl	SDRVDX_get_data (float *in_buffer_ptr []);
signed int cdecl	SDRVDX_is_playing (void);
signed int cdecl	SDRVDX_disconnect (void);
signed int cdecl	SDRVDX_connect (void);
signed int cdecl	SDRVDX_is_connected (void);
signed int cdecl	SDRVDX_get_message (char *text_0, long max_len);
signed int cdecl	SDRVDX_get_latency (void);
signed int cdecl	SDRVDX_set_latency (int t);



/*\\\ VARIABLES EXTERNES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ FIN DU FICHIER \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#endif

#undef SDRVDX_CURRENT_HEADER
